package Spec;

import br.ufpe.abaco.compiler.*;

public class TupleTerm extends ComposedTerm {
    private Term elems[];
    private int startPos;
    private int size;
    private StandardOperators stan;
    TupleTerm(Term e[],int start,StandardOperators st) {
	elems = e;
	startPos = start;
	size = e.length-startPos;
	stan = st;
    }

    Term[] getElements() {
        return elems;
    }

    public int size() {
	return elems.length-startPos;
    }
    public Term elementAt(int n) {
	n += startPos;
	if (n>elems.length)
	    return null;
	else
	    return elems[n];
    }

    public Operator getId() {
        return stan.concatOp;//"( _ , _ )";
    }
    
    public Term getLeaf(int i) {
	if (i==0)
	    return elems[startPos];
	else if (i==1) {
	    if (size==2)
		return elems[startPos+1];
	    else
		return new TupleTerm(elems,startPos+1,stan);
	} else 
	    return null;
    }

    public int arity() {
        return 2;    
    }
    
    public String toString() {
        StringBuffer  buf = new StringBuffer("( ");
        for (int i = startPos; i < elems.length; i++) {
	    if (i>startPos)
		buf.append(" , ");
            buf.append(elems[i].toString());
        }
	buf.append(" )");
        return buf.toString();
    }

    public static Term makeTuple(StandardOperators stan,Term t1,Term t2) {

	if (t1.getId() == stan.emptyTupleOp)
	    return t2;
	if (t2.getId() == stan.emptyTupleOp)
	    return t1;

	Term elems[];

	if (t1 instanceof TupleTerm) {
	    TupleTerm tu1 = (TupleTerm)t1;
	    int size1 = tu1.size;
	    if (t2 instanceof TupleTerm) {
		TupleTerm tu2 = (TupleTerm)t2;
		elems = new Term[size1+tu2.size];
		for (int c = tu2.size-1;c>=0;c--)
		    elems[c+size1] = tu2.elems[c+tu2.startPos];
	    }
	    else {
		elems = new Term[size1+1];
		elems[size1] = t2;
	    }
	    for (int c=0;c<size1;c++)
		elems[c] = tu1.elems[c+tu1.startPos];
	}
	else {
	    if (t2 instanceof TupleTerm) {
		TupleTerm tu = (TupleTerm)t2;
		int size = tu.size;
		elems = new Term[size+1];
		for (;size>0;size--)
		    elems[size] = tu.elems[size-1+tu.startPos];
	    }
	    else {
		elems = new Term[2];
		elems[1] = t2;
	    }
	    elems[0] = t1;
	}

	return new TupleTerm(elems,0,stan);
    }

}
